#include <math.h>

#include "hexagon.h"

#include "tap.h"

int main(void) {
	int start, x, y;

	plan_tests(6);

	x = 0; y = 0;
	start = HL_cantor_xy(x,y);
	ok(HL_center_x(start) == x * 1.5 / sqrt(3.0), "%d %d center X", x, y);
	ok(HL_center_y(start) == 0.0, "%d %d center Y", x, y);

	x = 1; y = 1;
	start = HL_cantor_xy(x,y);
	ok(HL_center_x(start) == x * 1.5 / sqrt(3.0), "%d %d center X", x, y);
	ok(HL_center_y(start) == 0.5, "%d %d center Y = %f", x, y,
			HL_center_y(start));

	x = 2; y = 2;
	start = HL_cantor_xy(x,y);
	ok(HL_center_x(start) == x * 1.5 / sqrt(3.0), "%d %d center X", x, y);
	ok(HL_center_y(start) == 2.0, "%d %d center Y = %f", x, y,
			HL_center_y(start));

	return exit_status();
}
