#include "hexagon.h"

#include "tap.h"

int main(void) {
	int x, y;

	plan_tests(6);

	HL_hexbin(1.0, 0.444194, -4.639363, &x, &y);
	ok(x == 1 && y == 4, "hexbin 0.444194, 4.639363 = 1, 4, %d %d", x, y);

        HL_hexbin(1.0, 0.0, 0.0, &x, &y);
        ok(x == 0 && y == 0, "0.0 0.0 -> 0 0");

        HL_hexbin(0.1111111, 0.288675, 0.500000, &x, &y);
        ok(x == 3, "center bin X %d == 3", x);
        ok(y == -5, "center bin Y %d == -5", y);

        HL_hexbin(0.1111111, 0.866025, 0.500000, &x, &y);
        ok(x == 9, "vertex bin X %d == 9", x);
        ok(y == -5, "vertex bin Y %d == -5", y);

	return exit_status();
}
